<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: phase_rgb_user_kernel.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>phase_rgb_user_kernel.c</h1><a href="phase__rgb__user__kernel_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00099"></a>00099 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00100"></a>00100 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00101"></a>00101 <span class="preprocessor">#include &lt;TI/tivx.h&gt;</span>
<a name="l00102"></a>00102 <span class="preprocessor">#include &lt;<a class="code" href="phase__rgb__user__kernel_8h.html">ch03_graph/phase_rgb_user_kernel.h</a>&gt;</span>
<a name="l00103"></a>00103 
<a name="l00105"></a><a class="code" href="phase__rgb__user__kernel_8c.html#a1c5d48e1731ea694529e9a0d772ce57f">00105</a> <span class="preprocessor">#define PHASE_RGB_IN0_IMG_IDX   (0u)</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00108"></a><a class="code" href="phase__rgb__user__kernel_8c.html#a1182feec6c80e38d758f284916141a9c">00108</a> <span class="preprocessor">#define PHASE_RGB_OUT0_IMG_IDX  (1u)</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>
<a name="l00111"></a><a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a">00111</a> <span class="preprocessor">#define PHASE_RGB_MAX_PARAMS    (2u)</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a>00113 <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#a7d7d2c869a100813bc3bf0ca85808a99" title="User/target kernel init function.">phase_rgb_user_kernel_init</a>(vx_node node,
<a name="l00114"></a>00114             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00115"></a>00115             vx_uint32 num);
<a name="l00116"></a>00116 <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#aaab492fc8853c4a4d487b39d80676a25" title="User/target kernel execute or run function.">phase_rgb_user_kernel_run</a>(vx_node node,
<a name="l00117"></a>00117             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00118"></a>00118             vx_uint32 num);
<a name="l00119"></a>00119 <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#a1d9397bcd330123d495c6990f18f1015" title="User/target kernel de-init function.">phase_rgb_user_kernel_deinit</a>(vx_node node,
<a name="l00120"></a>00120             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00121"></a>00121             vx_uint32 num);
<a name="l00122"></a>00122 <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#afb3302e5e0e9ec44562c7aaefdac5758" title="User/target kernel validate function.">phase_rgb_user_kernel_validate</a>(vx_node node,
<a name="l00123"></a>00123             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00124"></a>00124             vx_uint32 num,
<a name="l00125"></a>00125             vx_meta_format metas[]);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="keyword">static</span> vx_kernel <a class="code" href="phase__rgb__user__kernel_8c.html#a7c691dea4f45ce5f916b8a85755bd96a" title="Add kernel as user kernel.">phase_rgb_user_kernel_add_as_user_kernel</a>(vx_context context);
<a name="l00128"></a>00128 <span class="keyword">static</span> vx_kernel <a class="code" href="phase__rgb__user__kernel_8c.html#aba18efe50f3602ef221480ead3cf5879" title="Add kernel as target kernel.">phase_rgb_user_kernel_add_as_target_kernel</a>(vx_context context);
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="phase__rgb__user__kernel_8c.html#a3b79a7d30f81ffb2fb3860724609f919">00131</a> <span class="keyword">static</span> vx_kernel <a class="code" href="phase__rgb__user__kernel_8c.html#a3b79a7d30f81ffb2fb3860724609f919" title="Handle to the registered user kernel [static global].">phase_rgb_user_kernel</a> = NULL;
<a name="l00132"></a>00132 
<a name="l00134"></a><a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac">00134</a> <span class="keyword">static</span> vx_enum <a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac" title="Kernel ID of the registered user kernel. Used to create a node for the kernel function...">phase_rgb_user_kernel_id</a> = VX_ERROR_INVALID_PARAMETERS;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00144"></a><a class="code" href="phase__rgb__user__kernel_8h.html#a5e51581ab691a0e9037aed069be8495b">00144</a> vx_status <a class="code" href="phase__rgb__user__kernel_8c.html#a5e51581ab691a0e9037aed069be8495b" title="Add user/target kernel to OpenVX context.">phase_rgb_user_kernel_add</a>(vx_context context, vx_bool add_as_target_kernel)
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146     vx_kernel kernel = NULL;
<a name="l00147"></a>00147     vx_status status;
<a name="l00148"></a>00148     uint32_t index;
<a name="l00149"></a>00149 
<a name="l00156"></a>00156     <span class="keywordflow">if</span>(add_as_target_kernel==vx_false_e)
<a name="l00157"></a>00157     {
<a name="l00158"></a>00158         kernel = <a class="code" href="phase__rgb__user__kernel_8c.html#a7c691dea4f45ce5f916b8a85755bd96a" title="Add kernel as user kernel.">phase_rgb_user_kernel_add_as_user_kernel</a>(context);
<a name="l00159"></a>00159     }
<a name="l00160"></a>00160     <span class="keywordflow">if</span>(add_as_target_kernel==vx_true_e)
<a name="l00161"></a>00161     {
<a name="l00162"></a>00162         kernel = <a class="code" href="phase__rgb__user__kernel_8c.html#aba18efe50f3602ef221480ead3cf5879" title="Add kernel as target kernel.">phase_rgb_user_kernel_add_as_target_kernel</a>(context);
<a name="l00163"></a>00163     }
<a name="l00170"></a>00170     status = vxGetStatus((vx_reference)kernel);
<a name="l00172"></a>00172     <span class="keywordflow">if</span> ( status == VX_SUCCESS)
<a name="l00173"></a>00173     {
<a name="l00184"></a>00184         index = 0;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186         <span class="keywordflow">if</span> ( status == VX_SUCCESS)
<a name="l00187"></a>00187         {
<a name="l00188"></a>00188             status = vxAddParameterToKernel(kernel,
<a name="l00189"></a>00189                 index,
<a name="l00190"></a>00190                 VX_INPUT,
<a name="l00191"></a>00191                 VX_TYPE_IMAGE,
<a name="l00192"></a>00192                 VX_PARAMETER_STATE_REQUIRED
<a name="l00193"></a>00193                 );
<a name="l00194"></a>00194             index++;
<a name="l00195"></a>00195         }
<a name="l00196"></a>00196         <span class="keywordflow">if</span> ( status == VX_SUCCESS)
<a name="l00197"></a>00197         {
<a name="l00198"></a>00198             status = vxAddParameterToKernel(kernel,
<a name="l00199"></a>00199                 index,
<a name="l00200"></a>00200                 VX_OUTPUT,
<a name="l00201"></a>00201                 VX_TYPE_IMAGE,
<a name="l00202"></a>00202                 VX_PARAMETER_STATE_REQUIRED
<a name="l00203"></a>00203                 );
<a name="l00204"></a>00204             index++;
<a name="l00205"></a>00205         }
<a name="l00211"></a>00211         <span class="keywordflow">if</span> ( status == VX_SUCCESS)
<a name="l00212"></a>00212         {
<a name="l00213"></a>00213             status = vxFinalizeKernel(kernel);
<a name="l00214"></a>00214         }
<a name="l00216"></a>00216         <span class="keywordflow">if</span>( status != VX_SUCCESS)
<a name="l00217"></a>00217         {
<a name="l00218"></a>00218             printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_add: ERROR: vxAddParameterToKernel, vxFinalizeKernel failed (%d)!!!\n&quot;</span>, status);
<a name="l00219"></a>00219             vxReleaseKernel(&amp;kernel);
<a name="l00220"></a>00220             kernel = NULL;
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222     }
<a name="l00223"></a>00223     <span class="keywordflow">else</span>
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225         kernel = NULL;
<a name="l00226"></a>00226         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_add: ERROR: vxAddUserKernel failed (%d)!!!\n&quot;</span>, status);
<a name="l00227"></a>00227     }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00230"></a>00230     {
<a name="l00237"></a>00237         <a class="code" href="phase__rgb__user__kernel_8c.html#a3b79a7d30f81ffb2fb3860724609f919" title="Handle to the registered user kernel [static global].">phase_rgb_user_kernel</a> = kernel;
<a name="l00239"></a>00239         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_add: SUCCESS !!!\n&quot;</span>);
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     <span class="keywordflow">return</span> status;
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00252"></a><a class="code" href="phase__rgb__user__kernel_8c.html#a7c691dea4f45ce5f916b8a85755bd96a">00252</a> <span class="keyword">static</span> vx_kernel <a class="code" href="phase__rgb__user__kernel_8c.html#a7c691dea4f45ce5f916b8a85755bd96a" title="Add kernel as user kernel.">phase_rgb_user_kernel_add_as_user_kernel</a>(vx_context context)
<a name="l00253"></a>00253 {
<a name="l00254"></a>00254     vx_kernel kernel = NULL;
<a name="l00255"></a>00255     vx_status status;
<a name="l00256"></a>00256 
<a name="l00263"></a>00263     status = vxAllocateUserKernelId(context, &amp;<a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac" title="Kernel ID of the registered user kernel. Used to create a node for the kernel function...">phase_rgb_user_kernel_id</a>);
<a name="l00265"></a>00265     <span class="keywordflow">if</span>(status!=VX_SUCCESS)
<a name="l00266"></a>00266     {
<a name="l00267"></a>00267         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_add_as_user_kernel: ERROR: vxAllocateUserKernelId failed (%d)!!!\n&quot;</span>, status);
<a name="l00268"></a>00268     }
<a name="l00269"></a>00269     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00270"></a>00270     {
<a name="l00282"></a>00282         kernel = vxAddUserKernel(
<a name="l00283"></a>00283                     context,
<a name="l00284"></a>00284                     <span class="stringliteral">&quot;vx_tutorial_graph.phase_rgb&quot;</span>,
<a name="l00285"></a>00285                     <a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac" title="Kernel ID of the registered user kernel. Used to create a node for the kernel function...">phase_rgb_user_kernel_id</a>,
<a name="l00286"></a>00286                     <a class="code" href="phase__rgb__user__kernel_8c.html#aaab492fc8853c4a4d487b39d80676a25" title="User/target kernel execute or run function.">phase_rgb_user_kernel_run</a>,
<a name="l00287"></a>00287                     2, <span class="comment">/* number of parameters objects for this user function */</span>
<a name="l00288"></a>00288                     <a class="code" href="phase__rgb__user__kernel_8c.html#afb3302e5e0e9ec44562c7aaefdac5758" title="User/target kernel validate function.">phase_rgb_user_kernel_validate</a>,
<a name="l00289"></a>00289                     <a class="code" href="phase__rgb__user__kernel_8c.html#a7d7d2c869a100813bc3bf0ca85808a99" title="User/target kernel init function.">phase_rgb_user_kernel_init</a>,
<a name="l00290"></a>00290                     <a class="code" href="phase__rgb__user__kernel_8c.html#a1d9397bcd330123d495c6990f18f1015" title="User/target kernel de-init function.">phase_rgb_user_kernel_deinit</a>);
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294     <span class="keywordflow">return</span> kernel;
<a name="l00295"></a>00295 }
<a name="l00296"></a>00296 
<a name="l00304"></a><a class="code" href="phase__rgb__user__kernel_8c.html#aba18efe50f3602ef221480ead3cf5879">00304</a> <span class="keyword">static</span> vx_kernel <a class="code" href="phase__rgb__user__kernel_8c.html#aba18efe50f3602ef221480ead3cf5879" title="Add kernel as target kernel.">phase_rgb_user_kernel_add_as_target_kernel</a>(vx_context context)
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306     vx_kernel kernel;
<a name="l00307"></a>00307     vx_status status;
<a name="l00308"></a>00308 
<a name="l00318"></a>00318     <a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac" title="Kernel ID of the registered user kernel. Used to create a node for the kernel function...">phase_rgb_user_kernel_id</a> = <a class="code" href="vx__tutorial__kernels_8h.html#ad313f6307d27fea48432e16f1577d7bea81087035def5daa8186e02bc1f41979e" title="Converts Phase output to RGB image.">TIVX_TUTORIAL_KERNEL_PHASE_RGB</a>;
<a name="l00333"></a>00333     kernel = vxAddUserKernel(
<a name="l00334"></a>00334                 context,
<a name="l00335"></a>00335                 <span class="stringliteral">&quot;vx_tutorial_graph.phase_rgb&quot;</span>,
<a name="l00336"></a>00336                 <a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac" title="Kernel ID of the registered user kernel. Used to create a node for the kernel function...">phase_rgb_user_kernel_id</a>,
<a name="l00337"></a>00337                 NULL,
<a name="l00338"></a>00338                 2, <span class="comment">/* number of parameters objects for this user function */</span>
<a name="l00339"></a>00339                 <a class="code" href="phase__rgb__user__kernel_8c.html#afb3302e5e0e9ec44562c7aaefdac5758" title="User/target kernel validate function.">phase_rgb_user_kernel_validate</a>,
<a name="l00340"></a>00340                 NULL,
<a name="l00341"></a>00341                 NULL);
<a name="l00342"></a>00342 
<a name="l00343"></a>00343     status = vxGetStatus((vx_reference)kernel);
<a name="l00346"></a>00346     <span class="keywordflow">if</span> ( status == VX_SUCCESS)
<a name="l00347"></a>00347     {
<a name="l00353"></a>00353         tivxAddKernelTarget(kernel, TIVX_TARGET_DSP1);
<a name="l00354"></a>00354         tivxAddKernelTarget(kernel, TIVX_TARGET_DSP2);
<a name="l00356"></a>00356     }
<a name="l00357"></a>00357     <span class="keywordflow">return</span> kernel;
<a name="l00358"></a>00358 }
<a name="l00359"></a>00359 
<a name="l00365"></a><a class="code" href="phase__rgb__user__kernel_8h.html#a25ca1ab2d5d29d7d84d81ddc366a464c">00365</a> vx_status <a class="code" href="phase__rgb__user__kernel_8c.html#a25ca1ab2d5d29d7d84d81ddc366a464c" title="Remove user/target kernel from context.">phase_rgb_user_kernel_remove</a>(vx_context context)
<a name="l00366"></a>00366 {
<a name="l00367"></a>00367     vx_status status;
<a name="l00368"></a>00368 
<a name="l00374"></a>00374     status = vxRemoveKernel(<a class="code" href="phase__rgb__user__kernel_8c.html#a3b79a7d30f81ffb2fb3860724609f919" title="Handle to the registered user kernel [static global].">phase_rgb_user_kernel</a>);
<a name="l00375"></a>00375     <a class="code" href="phase__rgb__user__kernel_8c.html#a3b79a7d30f81ffb2fb3860724609f919" title="Handle to the registered user kernel [static global].">phase_rgb_user_kernel</a> = NULL;
<a name="l00378"></a>00378     <span class="keywordflow">if</span>(status!=VX_SUCCESS)
<a name="l00379"></a>00379     {
<a name="l00380"></a>00380         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_remove: Unable to remove kernel (%d)!!!\n&quot;</span>, status);
<a name="l00381"></a>00381     }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00384"></a>00384     {
<a name="l00385"></a>00385         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_remove: SUCCESS !!!\n&quot;</span>);
<a name="l00386"></a>00386     }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388     <span class="keywordflow">return</span> status;
<a name="l00389"></a>00389 }
<a name="l00390"></a>00390 
<a name="l00407"></a><a class="code" href="phase__rgb__user__kernel_8c.html#afb3302e5e0e9ec44562c7aaefdac5758">00407</a> <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#afb3302e5e0e9ec44562c7aaefdac5758" title="User/target kernel validate function.">phase_rgb_user_kernel_validate</a>(vx_node node,
<a name="l00408"></a>00408             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00409"></a>00409             vx_uint32 num,
<a name="l00410"></a>00410             vx_meta_format metas[])
<a name="l00411"></a>00411 {
<a name="l00412"></a>00412     vx_status status = VX_SUCCESS;
<a name="l00413"></a>00413     vx_image img[<a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a" title="Total number of parameters for this function.">PHASE_RGB_MAX_PARAMS</a>];
<a name="l00414"></a>00414     vx_uint32 w[<a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a" title="Total number of parameters for this function.">PHASE_RGB_MAX_PARAMS</a>];
<a name="l00415"></a>00415     vx_uint32 h[<a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a" title="Total number of parameters for this function.">PHASE_RGB_MAX_PARAMS</a>];
<a name="l00416"></a>00416     vx_uint32 out_w, out_h, i;
<a name="l00417"></a>00417     vx_df_image fmt[<a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a" title="Total number of parameters for this function.">PHASE_RGB_MAX_PARAMS</a>], out_fmt;
<a name="l00418"></a>00418 
<a name="l00419"></a>00419     <span class="keywordflow">if</span> (num != <a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a" title="Total number of parameters for this function.">PHASE_RGB_MAX_PARAMS</a>)
<a name="l00420"></a>00420     {
<a name="l00421"></a>00421         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: ERROR: Number of parameters dont match !!!\n&quot;</span>);
<a name="l00422"></a>00422         status = VX_ERROR_INVALID_PARAMETERS;
<a name="l00423"></a>00423     }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425     <span class="keywordflow">for</span> (i = 0U; i &lt; <a class="code" href="phase__rgb__user__kernel_8c.html#abee2067a26206b5dfb54f3d00f04fe2a" title="Total number of parameters for this function.">PHASE_RGB_MAX_PARAMS</a>; i ++)
<a name="l00426"></a>00426     {
<a name="l00427"></a>00427         img[i] = (vx_image)parameters[i];
<a name="l00428"></a>00428 
<a name="l00429"></a>00429         <span class="comment">/* Check for NULL */</span>
<a name="l00430"></a>00430         <span class="keywordflow">if</span> (NULL == img[i])
<a name="l00431"></a>00431         {
<a name="l00432"></a>00432             printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: ERROR: Parameter %d is NULL !!!\n&quot;</span>, i);
<a name="l00433"></a>00433             status = VX_ERROR_NO_MEMORY;
<a name="l00434"></a>00434             <span class="keywordflow">break</span>;
<a name="l00435"></a>00435         }
<a name="l00436"></a>00436     }
<a name="l00437"></a>00437     <span class="keywordflow">if</span> (VX_SUCCESS == status)
<a name="l00438"></a>00438     {
<a name="l00439"></a>00439         <span class="comment">/* Get the image width/heigh and format */</span>
<a name="l00440"></a>00440         status = vxQueryImage(img[<a class="code" href="phase__rgb__user__kernel_8c.html#a1c5d48e1731ea694529e9a0d772ce57f" title="Index of input image in parameter list.">PHASE_RGB_IN0_IMG_IDX</a>],
<a name="l00441"></a>00441             VX_IMAGE_FORMAT, &amp;fmt[PHASE_RGB_IN0_IMG_IDX],
<a name="l00442"></a>00442             <span class="keyword">sizeof</span>(vx_df_image));
<a name="l00443"></a>00443         status |= vxQueryImage(img[PHASE_RGB_IN0_IMG_IDX],
<a name="l00444"></a>00444             VX_IMAGE_WIDTH, &amp;w[PHASE_RGB_IN0_IMG_IDX],
<a name="l00445"></a>00445             <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00446"></a>00446         status |= vxQueryImage(img[PHASE_RGB_IN0_IMG_IDX],
<a name="l00447"></a>00447             VX_IMAGE_HEIGHT, &amp;h[PHASE_RGB_IN0_IMG_IDX],
<a name="l00448"></a>00448             <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00449"></a>00449 
<a name="l00450"></a>00450         <span class="keywordflow">if</span>(status!=VX_SUCCESS)
<a name="l00451"></a>00451         {
<a name="l00452"></a>00452             printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: ERROR: Unable to query input image !!!\n&quot;</span>);
<a name="l00453"></a>00453         }
<a name="l00454"></a>00454     }
<a name="l00455"></a>00455     <span class="keywordflow">if</span> ((VX_SUCCESS == status) &amp;&amp;
<a name="l00456"></a>00456         (vx_false_e == tivxIsReferenceVirtual(
<a name="l00457"></a>00457             parameters[<a class="code" href="phase__rgb__user__kernel_8c.html#a1182feec6c80e38d758f284916141a9c" title="Index of output image in parameter list.">PHASE_RGB_OUT0_IMG_IDX</a>])))
<a name="l00458"></a>00458     {
<a name="l00459"></a>00459         <span class="comment">/* Get the image width/heigh and format */</span>
<a name="l00460"></a>00460         status = vxQueryImage(img[PHASE_RGB_OUT0_IMG_IDX],
<a name="l00461"></a>00461             VX_IMAGE_FORMAT, &amp;fmt[PHASE_RGB_OUT0_IMG_IDX],
<a name="l00462"></a>00462             <span class="keyword">sizeof</span>(vx_df_image));
<a name="l00463"></a>00463         status |= vxQueryImage(img[PHASE_RGB_OUT0_IMG_IDX],
<a name="l00464"></a>00464             VX_IMAGE_WIDTH, &amp;w[PHASE_RGB_OUT0_IMG_IDX],
<a name="l00465"></a>00465             <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00466"></a>00466         status |= vxQueryImage(img[PHASE_RGB_OUT0_IMG_IDX],
<a name="l00467"></a>00467             VX_IMAGE_HEIGHT, &amp;h[PHASE_RGB_OUT0_IMG_IDX],
<a name="l00468"></a>00468             <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00469"></a>00469 
<a name="l00470"></a>00470         <span class="keywordflow">if</span>(status!=VX_SUCCESS)
<a name="l00471"></a>00471         {
<a name="l00472"></a>00472             printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: ERROR: Unable to query output image !!!\n&quot;</span>);
<a name="l00473"></a>00473         }
<a name="l00474"></a>00474     }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476     <span class="keywordflow">if</span> (VX_SUCCESS == status)
<a name="l00477"></a>00477     {
<a name="l00478"></a>00478         <span class="comment">/* Check for validity of data format */</span>
<a name="l00479"></a>00479         <span class="keywordflow">if</span> (VX_DF_IMAGE_U8 != fmt[<a class="code" href="phase__rgb__user__kernel_8c.html#a1c5d48e1731ea694529e9a0d772ce57f" title="Index of input image in parameter list.">PHASE_RGB_IN0_IMG_IDX</a>] &amp;&amp;
<a name="l00480"></a>00480             VX_DF_IMAGE_RGB != fmt[PHASE_RGB_OUT0_IMG_IDX]
<a name="l00481"></a>00481             )
<a name="l00482"></a>00482         {
<a name="l00483"></a>00483             status = VX_ERROR_INVALID_PARAMETERS;
<a name="l00484"></a>00484             printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: ERROR: Input/Output image format not correct !!!\n&quot;</span>);
<a name="l00485"></a>00485         }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487         <span class="comment">/* Check for frame sizes */</span>
<a name="l00488"></a>00488         <span class="keywordflow">if</span> (vx_false_e == tivxIsReferenceVirtual(
<a name="l00489"></a>00489             parameters[PHASE_RGB_OUT0_IMG_IDX]))
<a name="l00490"></a>00490         {
<a name="l00491"></a>00491             <span class="keywordflow">if</span> ((w[<a class="code" href="phase__rgb__user__kernel_8c.html#a1c5d48e1731ea694529e9a0d772ce57f" title="Index of input image in parameter list.">PHASE_RGB_IN0_IMG_IDX</a>] !=
<a name="l00492"></a>00492                  w[PHASE_RGB_OUT0_IMG_IDX]) ||
<a name="l00493"></a>00493                 (h[<a class="code" href="phase__rgb__user__kernel_8c.html#a1c5d48e1731ea694529e9a0d772ce57f" title="Index of input image in parameter list.">PHASE_RGB_IN0_IMG_IDX</a>] !=
<a name="l00494"></a>00494                  h[PHASE_RGB_OUT0_IMG_IDX]))
<a name="l00495"></a>00495             {
<a name="l00496"></a>00496                 status = VX_ERROR_INVALID_PARAMETERS;
<a name="l00497"></a>00497                 printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: ERROR: Input/Output image wxh do not match !!!\n&quot;</span>);
<a name="l00498"></a>00498             }
<a name="l00499"></a>00499         }
<a name="l00500"></a>00500     }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502     <span class="keywordflow">if</span> (VX_SUCCESS == status)
<a name="l00503"></a>00503     {
<a name="l00504"></a>00504         out_fmt = VX_DF_IMAGE_RGB;
<a name="l00505"></a>00505         out_w = w[PHASE_RGB_OUT0_IMG_IDX];
<a name="l00506"></a>00506         out_h = h[PHASE_RGB_OUT0_IMG_IDX];
<a name="l00507"></a>00507 
<a name="l00508"></a>00508         vxSetMetaFormatAttribute(metas[PHASE_RGB_OUT0_IMG_IDX], VX_IMAGE_FORMAT, &amp;out_fmt,
<a name="l00509"></a>00509             <span class="keyword">sizeof</span>(out_fmt));
<a name="l00510"></a>00510         vxSetMetaFormatAttribute(metas[PHASE_RGB_OUT0_IMG_IDX], VX_IMAGE_WIDTH, &amp;out_w,
<a name="l00511"></a>00511             <span class="keyword">sizeof</span>(out_w));
<a name="l00512"></a>00512         vxSetMetaFormatAttribute(metas[PHASE_RGB_OUT0_IMG_IDX], VX_IMAGE_HEIGHT, &amp;out_h,
<a name="l00513"></a>00513             <span class="keyword">sizeof</span>(out_h));
<a name="l00514"></a>00514     }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00517"></a>00517     {
<a name="l00518"></a>00518         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_validate: SUCCESS !!!\n&quot;</span>);
<a name="l00519"></a>00519     }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521     <span class="keywordflow">return</span> status;
<a name="l00522"></a>00522 }
<a name="l00523"></a>00523 
<a name="l00537"></a><a class="code" href="phase__rgb__user__kernel_8c.html#a7d7d2c869a100813bc3bf0ca85808a99">00537</a> <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#a7d7d2c869a100813bc3bf0ca85808a99" title="User/target kernel init function.">phase_rgb_user_kernel_init</a>(vx_node node,
<a name="l00538"></a>00538             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00539"></a>00539             vx_uint32 num)
<a name="l00540"></a>00540 {
<a name="l00541"></a>00541     printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_init: SUCCESS !!!\n&quot;</span>);
<a name="l00542"></a>00542     <span class="keywordflow">return</span> VX_SUCCESS;
<a name="l00543"></a>00543 }
<a name="l00544"></a>00544 
<a name="l00558"></a><a class="code" href="phase__rgb__user__kernel_8c.html#aaab492fc8853c4a4d487b39d80676a25">00558</a> <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#aaab492fc8853c4a4d487b39d80676a25" title="User/target kernel execute or run function.">phase_rgb_user_kernel_run</a>(vx_node node,
<a name="l00559"></a>00559             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00560"></a>00560             vx_uint32 num)
<a name="l00561"></a>00561 {
<a name="l00562"></a>00562     vx_image in_image = (vx_image)parameters[<a class="code" href="phase__rgb__user__kernel_8c.html#a1c5d48e1731ea694529e9a0d772ce57f" title="Index of input image in parameter list.">PHASE_RGB_IN0_IMG_IDX</a>];
<a name="l00563"></a>00563     vx_image out_image = (vx_image)parameters[<a class="code" href="phase__rgb__user__kernel_8c.html#a1182feec6c80e38d758f284916141a9c" title="Index of output image in parameter list.">PHASE_RGB_OUT0_IMG_IDX</a>];
<a name="l00564"></a>00564     vx_rectangle_t rect = { 0 };
<a name="l00565"></a>00565     vx_map_id in_map_id = (vx_map_id)VX_ERROR_INVALID_PARAMETERS, out_map_id = (vx_map_id)VX_ERROR_INVALID_PARAMETERS;
<a name="l00566"></a>00566     vx_imagepatch_addressing_t in_image_addr, out_image_addr;
<a name="l00567"></a>00567     vx_uint32 out_w=0, out_h=0;
<a name="l00568"></a>00568     vx_status status=0;
<a name="l00569"></a>00569     <span class="keywordtype">void</span> *in_data_ptr, *out_data_ptr;
<a name="l00570"></a>00570 
<a name="l00571"></a>00571     status |= vxQueryImage(out_image,
<a name="l00572"></a>00572         VX_IMAGE_WIDTH, &amp;out_w,
<a name="l00573"></a>00573         <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00574"></a>00574     status |= vxQueryImage(out_image,
<a name="l00575"></a>00575         VX_IMAGE_HEIGHT, &amp;out_h,
<a name="l00576"></a>00576         <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00577"></a>00577 
<a name="l00578"></a>00578     rect.start_x = 0;
<a name="l00579"></a>00579     rect.start_y = 0;
<a name="l00580"></a>00580     rect.end_x   = out_w;
<a name="l00581"></a>00581     rect.end_y   = out_h;
<a name="l00582"></a>00582 
<a name="l00583"></a>00583     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00584"></a>00584     {
<a name="l00585"></a>00585         status = vxMapImagePatch(in_image,
<a name="l00586"></a>00586                 &amp;rect,
<a name="l00587"></a>00587                 0,
<a name="l00588"></a>00588                 &amp;in_map_id,
<a name="l00589"></a>00589                 &amp;in_image_addr,
<a name="l00590"></a>00590                 (<span class="keywordtype">void</span>**)&amp;in_data_ptr,
<a name="l00591"></a>00591                 VX_READ_ONLY, VX_MEMORY_TYPE_HOST, VX_NOGAP_X);
<a name="l00592"></a>00592     }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00595"></a>00595     {
<a name="l00596"></a>00596         status = vxMapImagePatch(out_image,
<a name="l00597"></a>00597                 &amp;rect,
<a name="l00598"></a>00598                 0,
<a name="l00599"></a>00599                 &amp;out_map_id,
<a name="l00600"></a>00600                 &amp;out_image_addr,
<a name="l00601"></a>00601                 (<span class="keywordtype">void</span>**)&amp;out_data_ptr,
<a name="l00602"></a>00602                 VX_WRITE_ONLY, VX_MEMORY_TYPE_HOST, VX_NOGAP_X);
<a name="l00603"></a>00603     }
<a name="l00604"></a>00604     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00605"></a>00605     {
<a name="l00606"></a>00606         vx_uint32 x, y;
<a name="l00607"></a>00607 
<a name="l00608"></a>00608         <span class="keywordflow">for</span>(y=0; y&lt;out_image_addr.dim_y; y++)
<a name="l00609"></a>00609         {
<a name="l00610"></a>00610             <span class="keywordflow">for</span>(x=0; x&lt;out_image_addr.dim_x; x++)
<a name="l00611"></a>00611             {
<a name="l00612"></a>00612                 vx_uint8 *in_pixel = (vx_uint8 *)vxFormatImagePatchAddress2d(in_data_ptr, x, y, &amp;in_image_addr);
<a name="l00613"></a>00613                 vx_uint8 *out_pixel = (vx_uint8 *)vxFormatImagePatchAddress2d(out_data_ptr, x, y, &amp;out_image_addr);
<a name="l00614"></a>00614 
<a name="l00615"></a>00615                 <span class="keywordflow">if</span>(*in_pixel&lt;64)
<a name="l00616"></a>00616                 {
<a name="l00617"></a>00617                     out_pixel[0] = 0xFF;
<a name="l00618"></a>00618                     out_pixel[1] = 0x00;
<a name="l00619"></a>00619                     out_pixel[2] = 0x00;
<a name="l00620"></a>00620                 }
<a name="l00621"></a>00621                 <span class="keywordflow">else</span>
<a name="l00622"></a>00622                 <span class="keywordflow">if</span>(*in_pixel&lt;128)
<a name="l00623"></a>00623                 {
<a name="l00624"></a>00624                     out_pixel[0] = 0x00;
<a name="l00625"></a>00625                     out_pixel[1] = 0xFF;
<a name="l00626"></a>00626                     out_pixel[2] = 0x00;
<a name="l00627"></a>00627                 }
<a name="l00628"></a>00628                 <span class="keywordflow">else</span>
<a name="l00629"></a>00629                 <span class="keywordflow">if</span>(*in_pixel&lt;192)
<a name="l00630"></a>00630                 {
<a name="l00631"></a>00631                     out_pixel[0] = 0x00;
<a name="l00632"></a>00632                     out_pixel[1] = 0x00;
<a name="l00633"></a>00633                     out_pixel[2] = 0xFF;
<a name="l00634"></a>00634                 }
<a name="l00635"></a>00635                 <span class="keywordflow">else</span>
<a name="l00636"></a>00636                 {
<a name="l00637"></a>00637                     out_pixel[0] = 0xFF;
<a name="l00638"></a>00638                     out_pixel[1] = 0xFF;
<a name="l00639"></a>00639                     out_pixel[2] = 0xFF;
<a name="l00640"></a>00640                 }
<a name="l00641"></a>00641             }
<a name="l00642"></a>00642         }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644     }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646     <span class="keywordflow">if</span>(in_map_id!=(vx_map_id)VX_ERROR_INVALID_PARAMETERS)
<a name="l00647"></a>00647     {
<a name="l00648"></a>00648         vxUnmapImagePatch(in_image, in_map_id);
<a name="l00649"></a>00649     }
<a name="l00650"></a>00650     <span class="keywordflow">if</span>(out_map_id!=(vx_map_id)VX_ERROR_INVALID_PARAMETERS)
<a name="l00651"></a>00651     {
<a name="l00652"></a>00652         vxUnmapImagePatch(out_image, out_map_id);
<a name="l00653"></a>00653     }
<a name="l00654"></a>00654 
<a name="l00655"></a>00655     <span class="keywordflow">if</span>(status!=VX_SUCCESS)
<a name="l00656"></a>00656     {
<a name="l00657"></a>00657         printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_run: ERROR: Run failed (%d)!!!\n&quot;</span>, status);
<a name="l00658"></a>00658     }
<a name="l00659"></a>00659     <span class="keywordflow">return</span> status;
<a name="l00660"></a>00660 }
<a name="l00661"></a>00661 
<a name="l00674"></a><a class="code" href="phase__rgb__user__kernel_8c.html#a1d9397bcd330123d495c6990f18f1015">00674</a> <span class="keyword">static</span> vx_status VX_CALLBACK <a class="code" href="phase__rgb__user__kernel_8c.html#a1d9397bcd330123d495c6990f18f1015" title="User/target kernel de-init function.">phase_rgb_user_kernel_deinit</a>(vx_node node,
<a name="l00675"></a>00675             <span class="keyword">const</span> vx_reference parameters[ ],
<a name="l00676"></a>00676             vx_uint32 num)
<a name="l00677"></a>00677 {
<a name="l00678"></a>00678     printf(<span class="stringliteral">&quot; phase_rgb_user_kernel_deinit: SUCCESS !!!\n&quot;</span>);
<a name="l00679"></a>00679     <span class="keywordflow">return</span> VX_SUCCESS;
<a name="l00680"></a>00680 }
<a name="l00681"></a>00681 
<a name="l00697"></a><a class="code" href="phase__rgb__user__kernel_8h.html#a88488bc22b7681a4c2ad9cc7e80bd214">00697</a> vx_node <a class="code" href="phase__rgb__user__kernel_8c.html#a88488bc22b7681a4c2ad9cc7e80bd214" title="User/target kernel node create function.">phase_rgb_user_kernel_node</a>(vx_graph graph, vx_image in, vx_image out)
<a name="l00698"></a>00698 {
<a name="l00699"></a>00699     vx_node node;
<a name="l00704"></a>00704     vx_reference refs[] = {(vx_reference)in, (vx_reference)out};
<a name="l00711"></a>00711     node = tivxCreateNodeByKernelEnum(graph,
<a name="l00712"></a>00712                 <a class="code" href="phase__rgb__user__kernel_8c.html#aaac0a07f835c24f1c543e423fe3d54ac" title="Kernel ID of the registered user kernel. Used to create a node for the kernel function...">phase_rgb_user_kernel_id</a>,
<a name="l00713"></a>00713                 refs, <span class="keyword">sizeof</span>(refs)/<span class="keyword">sizeof</span>(refs[0])
<a name="l00714"></a>00714                 );
<a name="l00715"></a>00715     vxSetReferenceName((vx_reference)node, <span class="stringliteral">&quot;PHASE_RGB&quot;</span>);
<a name="l00718"></a>00718     <span class="keywordflow">return</span> node;
<a name="l00719"></a>00719 }
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
